package edu.mermet.tp8.fenetres;

import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

public class CommentFaire extends JDialog {

    private JList titres;
    private JEditorPane texte;

    private Properties propTitres;
    private Properties propTextes;

    private Action actQuitter;

    public CommentFaire(Action act) {
        this.actQuitter = act;
        initProperties();
        initTextes();
        init();
        setSize(900,300);
        setModal(false);
        setLocationRelativeTo(null);
    }

    private void init() {
        titres.addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                changeTexte((String) (titres.getSelectedValue()));
            }
        });
        titres.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        texte = new JEditorPane();
        texte.setContentType("text/html");
        texte.setEditable(false);
        JSplitPane pane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, new JScrollPane(titres), new JScrollPane(texte));
        add(pane);

        this.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                actQuitter.setEnabled(true);
            }
        });
    }

    private void initProperties() {
        propTitres = new Properties();
        try {
            propTitres.load(getClass().getClassLoader().getResourceAsStream("HowTo/titres.properties"));
        }catch(Exception e) { e.printStackTrace(); }
        propTextes = new Properties();
        try {
            propTextes.load(getClass().getClassLoader().getResourceAsStream("HowTo/textes.properties"));
        }catch(Exception e) { e.printStackTrace(); }
    }

    private void initTextes() {
        DefaultListModel<String> listModel = new DefaultListModel<String>();
        for ( String s : propTitres.stringPropertyNames()) {
            listModel.addElement(propTitres.getProperty(s));
        }
        titres = new JList(listModel);
    }

    private void changeTexte(String titre) {
        String key="";
        for ( String s : propTitres.stringPropertyNames()) {
            if ( titre.equals(propTitres.get(s)) ) key = s;
        }
        for ( String s : propTextes.stringPropertyNames()) {
            if ( key.equals(s) ) texte.setText(propTextes.getProperty(s));
        }
    }

}
